﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
namespace CopyFolder
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        private void button1_Click(object sender, EventArgs e)
        {
          DialogResult fb=   folderBrowserDialog1.ShowDialog();
          if (fb == DialogResult.OK)
              textBox1.Text  = folderBrowserDialog1.SelectedPath   ;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            DialogResult fb = folderBrowserDialog1.ShowDialog();
            if (fb == DialogResult.OK)
                textBox2.Text  =  folderBrowserDialog1.SelectedPath  ;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (textBox1.Text.Trim() != "" && textBox2.Text.Trim() != "")
            {
                DirectoryInfo source = new DirectoryInfo(textBox1.Text);
                DirectoryInfo destination = new DirectoryInfo(textBox2.Text);
                CopyDirectory(source, destination);
                MessageBox.Show("Copy success");
            }
        }
        void CopyDirectory(DirectoryInfo source, DirectoryInfo destination)
        {
            if (!destination.Exists)
                destination.Create();
            // Copy all files.
            FileInfo[] files = source.GetFiles();
            foreach (FileInfo file in files)
                file.CopyTo(Path.Combine(destination.FullName, file.Name));
            // Process subdirectories.
            DirectoryInfo[] dirs = source.GetDirectories();
            foreach (DirectoryInfo dir in dirs)
            {
                // Get destination directory.
                string destinationDir = Path.Combine(destination.FullName, dir.Name);
                // Call CopyDirectory() recursively.
                CopyDirectory(dir, new DirectoryInfo(destinationDir));
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            Close();
        }
    }
}
