﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
namespace Date
{
    class Date
    {
        private int  day;
        private int month;
        private int year;
        public Date(int y, int m, int d)
        {
            setYear(y);
            setMonth(m);
            setDay(d);
        }
        public int Day
        {
            get { return day; }
            set
            {
                setDay(value);
            }
        }
        public int Month
        {
            get { return month; }
            set
            {
                setMonth(value);
            }
        }
        public int Year
        {
            get { return year; }
            set 
            {
                setYear(value);
            }
        }
        private void setDay(int d)
        {
            if (month > 0 && month < 7)
                if (d > 0 &&  d <= 31) day = d;
                else day = 0;
            else if (month >= 7 && month < 12)
                if (d > 0 && d <= 30) day = d;
                else day = 0;
            else if (month == 12)
                if (d > 0 && d <= 29) day = d;
                else day = 0;

        }
        private void setMonth(int  m)
        {
            if (m > 0 && m <= 12)  month = m;
            else month = 0;
        } 
        private void setYear(int y)
        {
            if (y > 0) year = y;
            else year = 0;
        }
        public bool Equals(Date d1)
        {
            return (this.day == d1.day && this.month == d1.month && this.year == d1.year);
        }
        public Date nextDay()
        {
           Date  d1= new Date(0,0,0);
            d1 = this;
            d1.day++;
            if (d1.day > 31 && d1.month <= 6)
            {
                d1.month ++;
                d1.day = 1;
            }
            else if (d1.day > 30 && d1.month > 6  && d1.month <= 11)
            {
                d1.month ++;
                d1.day = 1;
            }
             else if (d1.day > 29 && d1.month == 12)
            {
                d1.month ++;
                d1.day = 1;
            }
            if (d1.month > 12)
            {
                d1.year++;
                d1.month = 1;
            }
            return d1;
        }
        public Date addDate(Date d)
        {
            Date d1 = new Date(0, 0, 0);
            d1.day = (int) this.day + d.day ;
            d1.month = (int)this.month + d.month;
            d1.year = (int)this.year + d.year;
            if (d1.day > 31 && d1.month <= 6)
            {
                d1.month++;
                if (d1.month == 7)
                    d1.day = 30 - d1.day;
                else
                    d1.day = 31 - d1.day;
                return d1;
            }
            if (d1.day  > 29 && d1.month == 12)
            {
                d1.month++;
                d1.day = 29 - d1.day;
                if (d1.month > 12)
                {
                    d1.month = 1;
                    d1.year++;
                }
                return d1;
            }
            if (d1.month  > 12 )
            {
                if (d1.day > 31)
                {
                    d1.month =  (d1.month + 1) % 12;
                    d1.day = d1.day - 29;
                }
                else d1.month = d1.month % 12;
                if (d1.month == 0) d1.month++;
                d1.year = d1.year + (int) d1.month / 12;
                return d1;
            }
            return d1;
        }
        public override string ToString()
        {
            string res = "";
            res = this.year.ToString() + "/";
            if (this.month < 10)
                res = res + "0" + this.month.ToString() + "/";
            else
                res = res + this.month.ToString() + "/";
            if (this.day < 10)
                res = res + "0" + this.day.ToString();
            else
                res = res + this.day.ToString();
            return res;
         
        }                                                                                                                                                   
        public static  Date operator -(Date d1, Date d2)
        {
            Date d3 = new Date(0, 0, 0);
            if (d1.day < d2.day )
            {
                if (d1.month <= 6)  d1.day = d1.day + 31;
                else if (d1.month <= 11) d1.day = d1.day + 30;
                else d1.day = d1.day + 29;
                d1.month = d1.month - 1;
            }
            if (d1.month  < d2.month )
            {
                d1.month = d1.month + 12;
                d1.year = d1.year - 1;
            }
            d3.day = d1.day - d2.day;
            d3.month = d1.month - d2.month;
            d3.year = d1.year - d2.year;
            return d3;
        }
        public bool chekDate()
        {
            return (!(this.day == 0 || this.month == 0 || this.year == 0));
        }
    }
}
